System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Machine.PowerStatus.powerLineStatusChanged = Render;
window.onload = Init;
var timer;

function Init(){
	debugLog('Init started');
	scanSkinDir();
	selectedSkin = Math.floor(Math.random()*100)%skin.length;
	get("selectedSkin");
	timeText = powerImage.addTextObject('', 'Tahoma', 0, "Black", 0,0);
	showRemainingTime = 1;
	get("showRemainingTime");
	size = 1; 
	get("size");
	Render();
	debugLog('Init finished');
}

function SettingsClosed(){
	debugLog("SettingsClosed()");
	Render();
}

function prettyTime(m){
	if(m<0) return '';
	debugLog('prettyTime(' + m + ')');
	h = Math.floor(m/60);
	m = Math.floor(m%60);
	prettyTimeText = (h>0?h+':':'') + (m<10&&h>0?'0'+m:m);
	debugLog('prettyTime = ' + prettyTimeText);
	return prettyTimeText;
}

function doubleClick(){
	selectedSkin=(selectedSkin+1)%skin.length;
	Render();
}

function setTimeText(str){
	debugLog("setting time text: " + str);
	timeText.value = str;
	timeText.top = 3;
	timeText.left = Math.ceil(128/size);
	timeText.fontSize = Math.ceil(13-size);	timeText.color = 'white';
	timeText.align = 2;
	timeText.addGlow("black", 2, 75);
}

function setPowerImage(){
	setTimeText(' ');
	var fileName = '';
	var level = Math.floor(System.Machine.PowerStatus.batteryPercentRemaining*9/100); //0-8=charging, 9=charged, -1=N/A
	if(System.Machine.PowerStatus.isBatteryCharging) { 
		level = level>8?8:level<0?0:level; //bugfix by Denis Valeev on 2009-03-03 
		if(skin[selectedSkin].chargingIconset) //can show charging icons for each level?
			fileName = 'c' + level;
		else if(skin[selectedSkin].chargingIcon) //well, what about just an icon for charging process?
			fileName = 'charging';
		else //none of the above leaves us with an icon of the current charge level
			fileName = level;
	}
	else {
		if(level < 0 || level > 9) //something's wrong with the gauge, trying to show the N/A icon
			fileName = skin[selectedSkin].naIcon?'na':8;
		else if(level == 9) //jeez, these go up to eleven, don't they?
			fileName = skin[selectedSkin].chargedIcon?'charged':'8';
		else
			fileName = level;
		//now we can show remaining time before the battery is dead
		if(showRemainingTime) 
			setTimeText(prettyTime(System.Machine.PowerStatus.batteryCapacityTotal/60));// + '\n' + System.Machine.PowerStatus.batteryPercentRemaining + '%');
	}
	powerImage.src = getImagePath(skin[selectedSkin].dir, fileName);
	powerImage.title = skin[selectedSkin].dir + '\n' + (System.Machine.PowerStatus.batteryPercentRemaining>100?'N/A':(System.Machine.PowerStatus.batteryPercentRemaining + '%'));

	debugLog("path to image: " + powerImage.src);
}

function getImagePath(dir, level){
	return 'images/'+ dir + '/' + level + '.png';
}

function Render()
{
	document.body.style.width = powerImage.style.width = Math.ceil(128/size);
	document.body.style.height = powerImage.style.height = Math.ceil(128/size);
	//debugLog("Rendering " + skin[selectedSkin].dir);	
	setPowerImage();
	clearTimeout(timer);
	timer = setTimeout(Render,1000); //checking back here again in one second
}
function scanSkinDir()
{   
	debugLog('scanSkinDir started');
	skin = Array();
    debugLog('Searching for skins...');
    try
    {
        var cursorObject = System.Shell.itemFromPath(System.Gadget.path + "\\images"); 
    }
    catch(e)
    {
        return null;
    }
    var cursor = cursorObject.SHFolder.Items;
    for(var i=0;i<cursor.count;i++)
    {
        if(cursor.item(i).isFolder)
        {
			try{
	        	processSkin(cursor.item(i).name);
			}
			catch(e){
				debugLog('processing skin "' + cursor.item(i).name + '" failed: ' + e);
			}
        }
    }

	debugLog('scanSkinDir finished');
}

function processSkin(skinName){
    debugLog('Processing skin: ' + skinName);
    try
    {
        var cursorObject = System.Shell.itemFromPath(System.Gadget.path + "\\images\\" + skinName); 
    }
    catch(e)
    {
        return null;
    }
    var cursor = cursorObject.SHFolder.Items;
    var _skin = {chargingIcon: false, naIcon: false, chargedIcon: false, level: 0, chargingLevel: 0, dir: skinName, name: skinName};
    if(cursorObject.type != "Compressed (zipped) Folder")
    {
        for(var i=0;i<cursor.count;i++)
        {
        		var itemPath = cursor.item(i).path;
        		
            if(!cursor.item(i).isFolder && itemPath.substr(itemPath.lastIndexOf(".")) == ".png")
            {
            	var itemName = cursor.item(i).name.replace('.png','');
              if(itemName >= "0" && itemName <= "8") _skin.level++;
              if(itemName >= "c0" && itemName <= "c8") _skin.chargingLevel++;
              if(itemName == "charging") _skin.chargingIcon = true;
              if(itemName == "na") _skin.naIcon = true;
              if(itemName == "charged") _skin.chargedIcon = true;
            }
        }
    }
    if(_skin.level != 9) //invalid skin check
    {
    	debugLog('missing some basic battery levels in the skin dir');
		return;
    }
    
    if(_skin.chargingLevel == 9) _skin.chargingIconset = true;
    skin.push(_skin);
}
